import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_LearningHARK001(self):
        self.zoom(3)
        self.setDisplay("Line", "Lines")

        # build main loop
        self.activateSheet("MAIN")
        for node in ["AudioStreamFromWave","MultiFFT","ConstantLocalization",
                     "GHDSS","PowerCalcForMap","HRLE","EstimateLeak",
                     "CalcSpecAddPower","CalcSpecSubGain","SpectralGainFilter",
                     "Synthesize","SaveRawPCM"]:
            self.addNode(node)

        self.reshape()
        self.connect("node_AudioStreamFromWave_1","AUDIO",
                     "node_MultiFFT_1","INPUT")
        self.connect("node_MultiFFT_1","OUTPUT",
                     "node_GHDSS_1","INPUT_FRAMES")
        self.connect("node_ConstantLocalization_1","SOURCES",
                     "node_GHDSS_1","INPUT_SOURCES")
        self.connect("node_GHDSS_1","OUTPUT",
                     "node_PowerCalcForMap_1","INPUT")
        self.connect("node_GHDSS_1","OUTPUT",
                     "node_SpectralGainFilter_1","INPUT_SPEC")
        self.connect("node_PowerCalcForMap_1","OUTPUT",
                     "node_HRLE_1","INPUT_SPEC")
        self.connect("node_PowerCalcForMap_1","OUTPUT",
                     "node_EstimateLeak_1","INPUT_POWER_SPEC")
        self.connect("node_HRLE_1","NOISE_SPEC",
                     "node_CalcSpecAddPower_1","INPUT_POWER_SPEC1")
        self.connect("node_EstimateLeak_1","LEAK_POWER_SPEC",
                     "node_CalcSpecAddPower_1","INPUT_POWER_SPEC2")
        self.connect("node_CalcSpecAddPower_1","OUTPUT_POWER_SPEC",
                     "node_CalcSpecSubGain_1","NOISE_SPEC")
        self.connect("node_PowerCalcForMap_1","OUTPUT",
                     "node_CalcSpecSubGain_1","INPUT_POWER_SPEC")
        #self.connect("node_CalcSpecSubGain_1","VOICE_PROB"
        #             "node_SpectralGainFilter_1","VOICE_PROB")
        self.connect("node_CalcSpecSubGain_1","GAIN",
                     "node_SpectralGainFilter_1","GAIN")
        self.connect("node_SpectralGainFilter_1","OUTPUT_SPEC",
                     "node_Synthesize_1","INPUT");
        self.connect("node_Synthesize_1","OUTPUT",
                     "node_SaveRawPCM_1","INPUT")

        self.addTerminalRole("node_AudioStreamFromWave_1","NOT_EOF","Condition");
        self.addTerminalRole("node_AudioStreamFromWave_1","INPUT","Input");
        self.addTerminalRole("node_SaveRawPCM_1","OUTPUT","Output");
        # raw_input()
        # build main
        self.screenshot("png", "demo-SeparationOfflineHRLE-MAIN_LOOP", True)

if __name__ == "__main__":
    unittest.main()
