import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_LearningHARK001(self):
        self.zoom(3)
        self.setDisplay("Line", "Lines")

        self.addSheet("MAIN_LOOP")

        # build main loop
        self.activateSheet("MAIN_LOOP")
        for node in ["Iterate", "AudioStreamFromMic",
                     "MatrixToMap", "SaveWavePCM"]:
            self.addNode(node)
        self.reshape()
        self.connect("node_MatrixToMap_1", "OUTPUT",
                     "node_SaveWavePCM_1", "INPUT")
        self.connect("node_AudioStreamFromMic_1", "AUDIO",
                     "node_MatrixToMap_1", "INPUT")
        self.addTerminalRole("node_SaveWavePCM_1", "OUTPUT", "Output", "")
        self.addTerminalRole("node_Iterate_1", "OUTPUT", "Condition", "")

        # build main
        self.activateSheet("MAIN")
        self.addNode("MAIN_LOOP")
        self.addTerminalRole("node_MAIN_LOOP_1", "OUTPUT", "Output", "")

        # take a picture
        self.screenshot("png")
        self.screenshot("png", "full_", True)

if __name__ == "__main__":
    unittest.main()
